/*
 * This file is part of rolas.
 *
 * Copyright © 2018 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace Rolas.Compiler {

    /**
     * Class for album field tokens.
     */
    public class AlbumFieldToken : FieldToken {

        /**
         * Sets up an album field token.
         */
        public AlbumFieldToken(int position) {
            base(position);
            original = "album";
        }

        /**
         * Returns the SQL representation of the album field token.
         * @return the SQL representation of the album field token.
         */
        public override string to_sql() {
            return " albums.name ";
        }
    }
}
