/*
 * This file is part of rolas.
 *
 * Copyright © 2018 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace Rolas.Compiler {

    /**
     * Error domain for syntax errors.
     */
    public errordomain SyntaxError {
        SYNTAX_ERROR;
    }

    /**
     * Returns a syntax error with a message.
     * @param message the message.
     * @return a syntax error with a message.
     */
    public static SyntaxError get_error(string message) {
        return new SyntaxError.SYNTAX_ERROR(message);
    }
}
