/*
 * This file is part of rolas.
 *
 * Copyright © 2018 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace Rolas {

    /**
     * Class for running a rolas application.
     */
    public class ApplicationMain {

        /**
         * Main entry point of the program.
         */
        public static int main(string[] args) {
            GLib.Environment.set_application_name("Rolas");
            Gtk.init(ref args);
            Gst.init(ref args);
            try {
                var opt = new GLib.OptionContext("Rolas database");
                opt.set_help_enabled(true);
                opt.parse(ref args);
            } catch (GLib.Error e) {
                GLib.warning(@"Error parsing options: $(e.message)");
            }

            var rolas = new Application();
            return rolas.run(args);
        }
    }
}
