/*
 * This file is part of rolas.
 *
 * Copyright © 2016-2017 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace Rolas {

    /**
     * Class for shortcuts windows.
     */
    [GtkTemplate (ui = "/mx/unam/ciencias/Rolas/shortcuts-window.ui")]
    public class ShortcutsWindow : Gtk.ShortcutsWindow {

        /* The on key press event callback. */
        [GtkCallback]
        private bool on_key_press_event(Gdk.EventKey event) {
            uint key;
            Gdk.keyval_convert_case(event.keyval, null, out key);
            if (key == Gdk.Key.W                                     &&
                ((event.state & Gdk.ModifierType.MOD1_MASK) != 0)    &&
                ((event.state & Gdk.ModifierType.CONTROL_MASK) != 0) &&
                ((event.state & Gdk.ModifierType.SHIFT_MASK) != 0)) {
                hide();
                return true;
            }
            return false;
        }
    }
}
